import { NgModule, EventEmitter, Injectable, Component, ViewChild, ElementRef, forwardRef, Inject, Injector, Optional, ViewEncapsulation, Compiler, ViewContainerRef } from '@angular/core';
import { CommonModule } from '@angular/common';
import { OCustomMaterialModule, OntimizeWebModule, DEFAULT_INPUTS_O_CURRENCY_INPUT, DEFAULT_INPUTS_O_DATE_INPUT, DEFAULT_INPUTS_O_EMAIL_INPUT, DEFAULT_INPUTS_O_INTEGER_INPUT, DEFAULT_INPUTS_O_NIF_INPUT, DEFAULT_INPUTS_O_PASSWORD_INPUT, DEFAULT_INPUTS_O_PERCENT_INPUT, DEFAULT_INPUTS_O_REAL_INPUT, DEFAULT_INPUTS_O_TEXT_INPUT, OTextInputComponent, DEFAULT_INPUTS_O_TEXTAREA_INPUT, DEFAULT_INPUTS_O_COLUMN, DEFAULT_INPUTS_O_ROW, DEFAULT_INPUTS_O_COMBO, OComboComponent, DEFAULT_INPUTS_O_LIST_PICKER, OListPickerComponent, DEFAULT_INPUTS_O_CHECKBOX, OCheckboxComponent, DEFAULT_INPUTS_O_TABLE, OTableComponent, InputConverter, OFormComponent, OFormValue, OntimizeService, SQLTypes, Util, ServiceUtils } from 'ontimize-web-ngx';
import { DndModule } from 'ng2-dnd';
import { __extends, __decorate, __metadata } from 'tslib';
import { ActivatedRoute } from '@angular/router';
import { Observable } from 'rxjs/Observable';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import 'rxjs/add/observable/combineLatest';
import { ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODynamicFormCustomMaterialModule = (function () {
    function ODynamicFormCustomMaterialModule() {
    }
    ODynamicFormCustomMaterialModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        OCustomMaterialModule
                    ],
                    exports: [
                        OCustomMaterialModule
                    ]
                },] },
    ];
    return ODynamicFormCustomMaterialModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODynamicFormEvents = (function () {
    // public addComponentEmitter: EventEmitter<Object>;
    function ODynamicFormEvents() {
        this.beforeSubmit = new EventEmitter();
        this.onSubmit = new EventEmitter();
        this.onInvalid = new EventEmitter();
        this.onChange = new EventEmitter();
        this.onRender = new EventEmitter();
        // this.addComponentEmitter = new EventEmitter();
        // this.errors = [];
        this.alerts = [];
    }
    ODynamicFormEvents.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    ODynamicFormEvents.ctorParameters = function () { return []; };
    return ODynamicFormEvents;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var /** @type {?} */ find = require('lodash/find');
var /** @type {?} */ cloneDeep = require('lodash/cloneDeep');
var DFComponents = (function () {
    function DFComponents() {
    }
    /**
     * @param {?} ontimizeDirective
     * @param {?} component
     * @param {?} template
     * @return {?}
     */
    DFComponents.register = /**
     * @param {?} ontimizeDirective
     * @param {?} component
     * @param {?} template
     * @return {?}
     */
    function (ontimizeDirective, component, template) {
        var /** @type {?} */ compTemplate = cloneDeep(template);
        compTemplate.module = compTemplate.module || {};
        compTemplate.component.selector = compTemplate.component.selector || 'odf-' + ontimizeDirective;
        compTemplate.component.inputs = compTemplate.component.inputs || ['component', 'data'];
        var /** @type {?} */ decoratedCmp = this.createCustomComponent(compTemplate.component);
        // Dynamic module
        if (!compTemplate.module.declarations) {
            compTemplate.module.declarations = [];
        }
        compTemplate.module.declarations.push(decoratedCmp);
        if (!compTemplate.module.imports) {
            compTemplate.module.imports = [];
        }
        // compTemplate.module.imports.push(CommonModule);
        // compTemplate.module.imports.push(ReactiveFormsModule);
        compTemplate.module.imports.push(DynamicFormModule);
        compTemplate.module.imports.push(DndModule);
        compTemplate.module.imports.push(OntimizeWebModule);
        var DynamicComponentModule = (function () {
            function DynamicComponentModule() {
            }
            DynamicComponentModule.decorators = [
                { type: NgModule, args: [compTemplate.module,] },
            ];
            return DynamicComponentModule;
        }());
        DFComponents.components[ontimizeDirective] = {
            component: component,
            metadata: compTemplate.component,
            module: DynamicComponentModule,
            factory: null
        };
    };
    /**
     * @param {?} component
     * @param {?} events
     * @param {?} data
     * @return {?}
     */
    DFComponents.createComponent = /**
     * @param {?} component
     * @param {?} events
     * @param {?} data
     * @return {?}
     */
    function (component, events, data) {
        var /** @type {?} */ ontimizeDirective = component['ontimize-directive'];
        var /** @type {?} */ comp = DFComponents.components[ontimizeDirective];
        if (!comp) {
            console.warn('There is a wrong component definition (ontimize-directive ="%s" does not exists): %O', ontimizeDirective, component);
            return undefined;
        }
        return new comp.component(component, events, data);
    };
    /**
     * @param {?} ontimizeDirective
     * @param {?} compiler
     * @return {?}
     */
    DFComponents.element = /**
     * @param {?} ontimizeDirective
     * @param {?} compiler
     * @return {?}
     */
    function (ontimizeDirective, compiler) {
        if (!DFComponents.components.hasOwnProperty(ontimizeDirective)) {
            ontimizeDirective = 'custom';
        }
        if (DFComponents.components[ontimizeDirective].factoryPromise) {
            return DFComponents.components[ontimizeDirective].factoryPromise;
        }
        DFComponents.components[ontimizeDirective].factoryPromise =
            compiler.compileModuleAndAllComponentsAsync(DFComponents.components[ontimizeDirective].module).then(function (moduleWithFactories) {
                var /** @type {?} */ factory = find(moduleWithFactories.componentFactories, { selector: 'odf-' + ontimizeDirective });
                return factory;
            });
        return DFComponents.components[ontimizeDirective].factoryPromise;
    };
    /**
     * @param {?} compDefinition
     * @return {?}
     */
    DFComponents.createCustomComponent = /**
     * @param {?} compDefinition
     * @return {?}
     */
    function (compDefinition) {
        var CustomDynamicComponent = (function () {
            function CustomDynamicComponent() {
                this.renderCount = 0;
            }
            Object.defineProperty(CustomDynamicComponent.prototype, "numComponents", {
                get: /**
                 * @return {?}
                 */
                function () {
                    return this.component.getNumComponents();
                },
                enumerable: true,
                configurable: true
            });
            /**
             * @return {?}
             */
            CustomDynamicComponent.prototype.ngOnInit = /**
             * @return {?}
             */
            function () {
                this.setOntimizeComponentInputs();
            };
            /**
             * @return {?}
             */
            CustomDynamicComponent.prototype.ngAfterViewInit = /**
             * @return {?}
             */
            function () {
                this.onRender();
            };
            /**
             * @return {?}
             */
            CustomDynamicComponent.prototype.setOntimizeComponentInputs = /**
             * @return {?}
             */
            function () {
                if (this.component && this.ontimizeComponent) {
                    var /** @type {?} */ inputsMapping = this.component.getInputsMapping();
                    for (var /** @type {?} */ i = 0; i < inputsMapping.length; i++) {
                        var /** @type {?} */ curr = inputsMapping[i];
                        if (this.component.settings.hasOwnProperty(curr.input)) {
                            this.ontimizeComponent[curr.propName] = this.component.settings[curr.input];
                        }
                    }
                }
            };
            /**
             * @return {?}
             */
            CustomDynamicComponent.prototype.onRender = /**
             * @return {?}
             */
            function () {
                if (!this.render) {
                    return;
                }
                if (this.renderCount > this.numComponents) {
                    return;
                }
                this.renderCount++;
                if (this.renderCount > this.numComponents) {
                    this.render.emit(true);
                }
            };
            CustomDynamicComponent.decorators = [
                { type: Component, args: [compDefinition,] },
            ];
            /** @nocollapse */
            CustomDynamicComponent.propDecorators = {
                "ontimizeComponent": [{ type: ViewChild, args: ['ontimizeComponent',] },],
            };
            return CustomDynamicComponent;
        }());
        return CustomDynamicComponent;
    };
    DFComponents.components = {};
    return DFComponents;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template T
 */
var /**
 * @template T
 */
BaseComponent = (function () {
    function BaseComponent(settings, events, data) {
        if (data === void 0) { data = {}; }
        this.settings = settings;
        this.events = events;
        this.data = data;
        this.index = 0;
    }
    /**
     * @return {?}
     */
    BaseComponent.prototype.getNumComponents = /**
     * @return {?}
     */
    function () {
        return this.isContainerComponent() ? this.getChildren().length : 0;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.allowMultiple = /**
     * @return {?}
     */
    function () {
        return this.settings.multiple;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return [];
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.getInputsMapping = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ rawProperties = this.getInputsProperties();
        var /** @type {?} */ parsedProperties = [];
        for (var /** @type {?} */ i = 0; i < rawProperties.length; i++) {
            var /** @type {?} */ splitted = rawProperties[i].split(':');
            var /** @type {?} */ propObj = {
                propName: splitted[0].trim(),
                input: splitted[splitted.length - 1].trim()
            };
            parsedProperties.push(propObj);
        }
        return parsedProperties;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.isContainerComponent = /**
     * @return {?}
     */
    function () {
        return false;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.getChildren = /**
     * @return {?}
     */
    function () {
        return this.settings.children;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.getComponentAttr = /**
     * @return {?}
     */
    function () {
        return this.settings.attr;
    };
    /**
     * @return {?}
     */
    BaseComponent.prototype.getChildrenAttrs = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ attrs = [];
        this._getChildrenAttrsFromSettings(this.settings, attrs);
        return attrs;
    };
    /**
     * @param {?} element
     * @param {?} attrs
     * @return {?}
     */
    BaseComponent.prototype._getChildrenAttrsFromSettings = /**
     * @param {?} element
     * @param {?} attrs
     * @return {?}
     */
    function (element, attrs) {
        var _this = this;
        attrs.push(element['attr']);
        if (element['children']) {
            element['children'].forEach(function (e) {
                _this._getChildrenAttrsFromSettings(e, attrs);
            });
        }
        return attrs;
    };
    return BaseComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template T
 */
var /**
 * @template T
 */
InputComponent = (function (_super) {
    __extends(InputComponent, _super);
    function InputComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    return InputComponent;
}(BaseComponent));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CurrencyFieldComponent = (function (_super) {
    __extends(CurrencyFieldComponent, _super);
    function CurrencyFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    CurrencyFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_CURRENCY_INPUT;
    };
    return CurrencyFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOCurrencyInput(template) {
    DFComponents.register('o-currency-input', CurrencyFieldComponent, template.components['o-currency-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DateFieldComponent = (function (_super) {
    __extends(DateFieldComponent, _super);
    function DateFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    DateFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_DATE_INPUT;
    };
    return DateFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfODateInput(template) {
    DFComponents.register('o-date-input', DateFieldComponent, template.components['o-date-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var EmailFieldComponent = (function (_super) {
    __extends(EmailFieldComponent, _super);
    function EmailFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    EmailFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_EMAIL_INPUT;
    };
    return EmailFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOEmailInput(template) {
    DFComponents.register('o-email-input', EmailFieldComponent, template.components['o-email-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var IntegerFieldComponent = (function (_super) {
    __extends(IntegerFieldComponent, _super);
    function IntegerFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    IntegerFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_INTEGER_INPUT;
    };
    return IntegerFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOIntegerInput(template) {
    DFComponents.register('o-integer-input', IntegerFieldComponent, template.components['o-integer-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var NifFieldComponent = (function (_super) {
    __extends(NifFieldComponent, _super);
    function NifFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    NifFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_NIF_INPUT;
    };
    return NifFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfONifInput(template) {
    DFComponents.register('o-nif-input', NifFieldComponent, template.components['o-nif-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PasswordFieldComponent = (function (_super) {
    __extends(PasswordFieldComponent, _super);
    function PasswordFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    PasswordFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_PASSWORD_INPUT;
    };
    return PasswordFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOPasswordInput(template) {
    DFComponents.register('o-password-input', PasswordFieldComponent, template.components['o-password-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var PercentFieldComponent = (function (_super) {
    __extends(PercentFieldComponent, _super);
    function PercentFieldComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    PercentFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_PERCENT_INPUT;
    };
    return PercentFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOPercentInput(template) {
    DFComponents.register('o-percent-input', PercentFieldComponent, template.components['o-percent-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var RealFieldComponent = (function (_super) {
    __extends(RealFieldComponent, _super);
    function RealFieldComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    RealFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_REAL_INPUT;
    };
    return RealFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfORealInput(template) {
    DFComponents.register('o-real-input', RealFieldComponent, template.components['o-real-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TextFieldComponent = (function (_super) {
    __extends(TextFieldComponent, _super);
    function TextFieldComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    TextFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_TEXT_INPUT;
    };
    /**
     * @return {?}
     */
    TextFieldComponent.prototype.getOntimizeComponentClass = /**
     * @return {?}
     */
    function () {
        return OTextInputComponent;
    };
    return TextFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOTextInput(template) {
    DFComponents.register('o-text-input', TextFieldComponent, template.components['o-text-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TextareaFieldComponent = (function (_super) {
    __extends(TextareaFieldComponent, _super);
    function TextareaFieldComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    TextareaFieldComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_TEXTAREA_INPUT;
    };
    return TextareaFieldComponent;
}(InputComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOTextareaInput(template) {
    DFComponents.register('o-textarea-input', TextareaFieldComponent, template.components['o-textarea-input']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var OColumnComponent = (function (_super) {
    __extends(OColumnComponent, _super);
    function OColumnComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    OColumnComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_COLUMN;
    };
    /**
     * @return {?}
     */
    OColumnComponent.prototype.isContainerComponent = /**
     * @return {?}
     */
    function () {
        return true;
    };
    return OColumnComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOColumn(template) {
    DFComponents.register('o-column', OColumnComponent, template.components['o-column']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ORowComponent = (function (_super) {
    __extends(ORowComponent, _super);
    function ORowComponent(settings, events, data) {
        return _super.call(this, settings, events, data) || this;
    }
    /**
     * @return {?}
     */
    ORowComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_ROW;
    };
    /**
     * @return {?}
     */
    ORowComponent.prototype.isContainerComponent = /**
     * @return {?}
     */
    function () {
        return true;
    };
    return ORowComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfORow(template) {
    DFComponents.register('o-row', ORowComponent, template.components['o-row']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ComboComponent = (function (_super) {
    __extends(ComboComponent, _super);
    function ComboComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    ComboComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_COMBO;
    };
    /**
     * @return {?}
     */
    ComboComponent.prototype.getOntimizeComponentClass = /**
     * @return {?}
     */
    function () {
        return OComboComponent;
    };
    return ComboComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOCombo(template) {
    DFComponents.register('o-combo', ComboComponent, template.components['o-combo']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ListPickerComponent = (function (_super) {
    __extends(ListPickerComponent, _super);
    function ListPickerComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    ListPickerComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_LIST_PICKER;
    };
    /**
     * @return {?}
     */
    ListPickerComponent.prototype.getOntimizeComponentClass = /**
     * @return {?}
     */
    function () {
        return OListPickerComponent;
    };
    return ListPickerComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOListPicker(template) {
    DFComponents.register('o-list-picker', ListPickerComponent, template.components['o-list-picker']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CheckboxComponent = (function (_super) {
    __extends(CheckboxComponent, _super);
    function CheckboxComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    CheckboxComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_CHECKBOX;
    };
    /**
     * @return {?}
     */
    CheckboxComponent.prototype.getOntimizeComponentClass = /**
     * @return {?}
     */
    function () {
        return OCheckboxComponent;
    };
    return CheckboxComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOCheckbox(template) {
    DFComponents.register('o-checkbox', CheckboxComponent, template.components['o-checkbox']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var TableComponent = (function (_super) {
    __extends(TableComponent, _super);
    function TableComponent(settings, data) {
        return _super.call(this, settings, data) || this;
    }
    /**
     * @return {?}
     */
    TableComponent.prototype.getInputsProperties = /**
     * @return {?}
     */
    function () {
        return DEFAULT_INPUTS_O_TABLE;
    };
    /**
     * @return {?}
     */
    TableComponent.prototype.getOntimizeComponentClass = /**
     * @return {?}
     */
    function () {
        return OTableComponent;
    };
    return TableComponent;
}(BaseComponent));
/**
 * @param {?} template
 * @return {?}
 */
function OdfOTable(template) {
    DFComponents.register('o-table', TableComponent, template.components['o-table']);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @param {?} template
 * @return {?}
 */
function RegisterComponents(template) {
    OdfOCurrencyInput(template);
    OdfODateInput(template);
    OdfOEmailInput(template);
    OdfOIntegerInput(template);
    OdfONifInput(template);
    OdfOPasswordInput(template);
    OdfOPercentInput(template);
    OdfORealInput(template);
    OdfOTextInput(template);
    OdfOTextareaInput(template);
    OdfOColumn(template);
    OdfORow(template);
    OdfOCombo(template);
    OdfOListPicker(template);
    OdfOCheckbox(template);
    OdfOTable(template);
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var /** @type {?} */ getTemplate = function (selector, template, styles, inputs, module) {
    if (styles === void 0) { styles = []; }
    if (inputs === void 0) { inputs = []; }
    if (module === void 0) { module = {}; }
    return {
        component: {
            selector: selector,
            template: template,
            styles: styles,
            inputs: inputs
        },
        module: module
    };
};
var /** @type {?} */ containerInputs = ['component', 'data', 'addCompontentEmitter : add-component-emitter', 'editMode : edit-mode'];
var /** @type {?} */ DYNAMIC_FORM_BOOTSTRAP = {
    components: {
        'o-currency-input': getTemplate('odf-o-currency-input', require('./bootstrap/components/odf-o-currency-input.component.html')),
        'o-date-input': getTemplate('odf-o-date-input', require('./bootstrap/components/odf-o-date-input.component.html')),
        'o-email-input': getTemplate('odf-o-email-input', require('./bootstrap/components/odf-o-email-input.component.html')),
        'o-integer-input': getTemplate('odf-o-integer-input', require('./bootstrap/components/odf-o-integer-input.component.html')),
        'o-nif-input': getTemplate('odf-o-nif-input', require('./bootstrap/components/odf-o-nif-input.component.html')),
        'o-password-input': getTemplate('odf-o-password-input', require('./bootstrap/components/odf-o-password-input.component.html')),
        'o-percent-input': getTemplate('odf-o-percent-input', require('./bootstrap/components/odf-o-percent-input.component.html')),
        'o-real-input': getTemplate('odf-o-real-input', require('./bootstrap/components/odf-o-real-input.component.html')),
        'o-text-input': getTemplate('odf-o-text-input', require('./bootstrap/components/odf-o-text-input.component.html')),
        'o-textarea-input': getTemplate('odf-o-textarea-input', require('./bootstrap/components/odf-o-textarea-input.component.html')),
        'o-row': getTemplate('odf-o-row', require('./bootstrap/components/odf-o-row.component.html')),
        'o-column': getTemplate('odf-o-column', require('./bootstrap/components/odf-o-column.component.html'), [], containerInputs),
        'o-combo': getTemplate('odf-o-combo', require('./bootstrap/components/odf-o-combo.component.html')),
        'o-list-picker': getTemplate('odf-o-list-picker', require('./bootstrap/components/odf-o-list-picker.component.html')),
        'o-checkbox': getTemplate('odf-o-checkbox', require('./bootstrap/components/odf-o-checkbox.component.html')),
        'o-table': getTemplate('odf-o-table', require('./bootstrap/components/odf-o-table.component.html'))
    }
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODynamicFormComponent = (function () {
    function ODynamicFormComponent(actRoute, injector, events, elRef, parentForm) {
        this.actRoute = actRoute;
        this.injector = injector;
        this.events = events;
        this.elRef = elRef;
        this.parentForm = parentForm;
        this.ready = new BehaviorSubject(false);
        this.editMode = false;
        this.keys = '';
        this.parentKeys = '';
        this.columns = '';
        this.queryOnInit = true;
        this.queryOnBind = true;
        this.queryOnRender = true;
        this.registerInParentForm = true;
        this.autoBinding = true;
        this.autoRegistering = true;
        /* end of inputs */
        /*parsed inputs */
        this.innerFormDefinition = null;
        this.keysArray = [];
        this.colsArray = [];
        this._pKeysEquiv = {};
        /* end of parsed inputs */
        this.render = new EventEmitter();
        this.submit = new EventEmitter();
        this.change = new EventEmitter();
        this.onAddComponent = new EventEmitter();
        this.onMoveComponent = new EventEmitter();
        this.onEditComponentSettings = new EventEmitter();
        this.onDeleteComponent = new EventEmitter();
        this.onDynamicFormDataLoaded = new EventEmitter();
        this.onFormInitStream = new EventEmitter();
        this.onUrlParamChangedStream = new EventEmitter();
        this.loading = false;
        this.formData = {};
        this.reloadStream = Observable.combineLatest(this.onFormInitStream.asObservable(), this.onUrlParamChangedStream.asObservable());
        var /** @type {?} */ self = this;
        this.reloadStream.subscribe(function (valArr) {
            if (Util.isArray(valArr) && valArr.length === 2) {
                if (self.queryOnInit && valArr[0] === true && valArr[1] === true) {
                    self.doQuery(true);
                }
            }
        });
    }
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.formDefinition) {
            this.ready.next(true);
        }
        this.keysArray = Util.parseArray(this.keys);
        this.colsArray = Util.parseArray(this.columns);
        var /** @type {?} */ pkArray = Util.parseArray(this.parentKeys);
        this._pKeysEquiv = Util.parseParentKeysEquivalences(pkArray);
        this.configureService();
        this.registerFormListeners();
        var /** @type {?} */ self = this;
        this.urlParamSub = this.actRoute.params.subscribe(function (params) {
            self.urlParams = params;
            if (self.urlParams && Object.keys(self.urlParams).length > 0) {
                self.onUrlParamChangedStream.emit(true);
            }
        });
        if (this.parentForm) {
            if (self.queryOnBind) {
                this.onFormDataSubscribe = this.parentForm.onFormDataLoaded.subscribe(function (data) {
                    var /** @type {?} */ filter = ServiceUtils.getParentItemFromForm(undefined, self._pKeysEquiv, self.parentForm);
                    self.queryData(filter);
                });
            }
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getSQLType = /**
     * @return {?}
     */
    function () {
        return SQLTypes.OTHER;
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getAttribute = /**
     * @return {?}
     */
    function () {
        if (this.oattr) {
            return this.oattr;
        }
        else if (this.elRef && this.elRef.nativeElement.attributes['attr']) {
            return this.elRef.nativeElement.attributes['attr'].value;
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.onFormInitStream.emit(true);
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.configureService = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ loadingService = OntimizeService;
        if (this.serviceType) {
            loadingService = this.serviceType;
        }
        try {
            this.dataService = this.injector.get(loadingService);
            if (Util.isDataService(this.dataService)) {
                var /** @type {?} */ serviceCfg = this.dataService.getDefaultServiceConfiguration(this.service);
                if (this.entity) {
                    serviceCfg['entity'] = this.entity;
                }
                this.dataService.configureService(serviceCfg);
            }
        }
        catch (/** @type {?} */ e) {
            console.error(e);
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.registerFormListeners = /**
     * @return {?}
     */
    function () {
        if (this.parentForm && this.registerInParentForm) {
            this.parentForm.registerFormComponent(this);
            this.parentForm.registerDynamicFormComponent(this);
            this.parentForm.registerSQLTypeFormComponent(this);
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.unregisterFormListeners = /**
     * @return {?}
     */
    function () {
        if (this.parentForm && this.registerInParentForm) {
            this.parentForm.unregisterFormComponent(this);
            this.parentForm.unregisterDynamicFormComponent(this);
            this.parentForm.unregisterSQLTypeFormComponent(this);
        }
    };
    /**
     * @param {?} val
     * @return {?}
     */
    ODynamicFormComponent.prototype.setValue = /**
     * @param {?} val
     * @return {?}
     */
    function (val) {
        this.formDefinition = val;
    };
    Object.defineProperty(ODynamicFormComponent.prototype, "data", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            var /** @type {?} */ formDef = undefined;
            if (value instanceof OFormValue) {
                formDef = value.value;
            }
            if (!formDef) {
                formDef = {};
            }
            this.formDefinition = formDef;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.isAutomaticBinding = /**
     * @return {?}
     */
    function () {
        return this.autoBinding;
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.isAutomaticRegistering = /**
     * @return {?}
     */
    function () {
        return this.autoRegistering;
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getCurrentKeysValues = /**
     * @return {?}
     */
    function () {
        var _this = this;
        var /** @type {?} */ filter = {};
        if (this.urlParams && this.keysArray) {
            this.keysArray.map(function (key) {
                if (_this.urlParams[key]) {
                    filter[key] = _this.urlParams[key];
                }
            });
        }
        var /** @type {?} */ keys = Object.keys(this._pKeysEquiv);
        if (this.urlParams && keys && keys.length > 0) {
            keys.forEach(function (item) {
                var /** @type {?} */ urlVal = _this.urlParams[_this._pKeysEquiv[item]];
                if (urlVal) {
                    filter[item] = urlVal;
                }
            });
        }
        return filter;
    };
    /**
     * @param {?=} useFilter
     * @return {?}
     */
    ODynamicFormComponent.prototype.doQuery = /**
     * @param {?=} useFilter
     * @return {?}
     */
    function (useFilter) {
        if (useFilter === void 0) { useFilter = false; }
        var /** @type {?} */ filter = {};
        if (useFilter) {
            filter = this.getCurrentKeysValues();
        }
        this.queryData(filter);
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getAttributesToQuery = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ attributes = [];
        // add form keys...
        if (this.keysArray && this.keysArray.length > 0) {
            attributes.push.apply(attributes, this.keysArray);
        }
        if (this.oattr) {
            attributes.push(this.oattr);
        }
        return attributes;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ODynamicFormComponent.prototype._setData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (Util.isArray(data) && data.length === 1) {
            this.formData = data[0];
            this._emitData(this.formData);
        }
        else if (Util.isObject(data)) {
            this.formData = data;
            this._emitData(this.formData);
        }
        else {
            console.warn('DynamicForm has received not supported service data. Supported data are Array or Object');
        }
        if (this.oattr) {
            var /** @type {?} */ dynamicData = this.formData[this.oattr];
            this.formDefinition = dynamicData;
        }
    };
    /**
     * @param {?} data
     * @return {?}
     */
    ODynamicFormComponent.prototype._emitData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.onDynamicFormDataLoaded.emit(data);
    };
    /**
     * @param {?} filter
     * @return {?}
     */
    ODynamicFormComponent.prototype.queryData = /**
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        if (!Util.isDefined(filter) || (Util.isObject(filter) && Object.keys(filter).length === 0)) {
            return;
        }
        var /** @type {?} */ self = this;
        var /** @type {?} */ loader = self.load();
        if (this.dataService === undefined) {
            console.warn('No service configured! aborting query');
            return;
        }
        // let sqlTypes = this.getAttributesSQLTypes();
        this.dataService.query(filter, this.getAttributesToQuery(), this.entity).subscribe(function (resp) {
            loader.unsubscribe();
            if (resp.code === 0) {
                self._setData(resp.data);
            }
            else {
                console.log('error ');
            }
        }, function (err) {
            console.log(err);
            loader.unsubscribe();
        });
    };
    Object.defineProperty(ODynamicFormComponent.prototype, "areEmptyComponents", {
        get: /**
         * @return {?}
         */
        function () {
            if (this.formDefinition && this.formDefinition.components) {
                return this.formDefinition.components.length === 0;
            }
            return true;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.urlParamSub) {
            this.urlParamSub.unsubscribe();
        }
        this.unregisterFormListeners();
        if (this.onFormDataSubscribe) {
            this.onFormDataSubscribe.unsubscribe();
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.onComponentRendered = /**
     * @return {?}
     */
    function () {
        // The form is done rendering.
        if (this.render) {
            this.render.emit(this.queryOnRender);
        }
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.load = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ self = this;
        var /** @type {?} */ loadObservable = new Observable(function (observer) {
            var /** @type {?} */ timer = window.setTimeout(function () {
                observer.next(true);
            }, 250);
            return function () {
                window.clearTimeout(timer);
                self.loading = false;
            };
        });
        var /** @type {?} */ subscription = loadObservable.subscribe(function (val) {
            self.loading = /** @type {?} */ (val);
        });
        return subscription;
    };
    Object.defineProperty(ODynamicFormComponent.prototype, "formDefinition", {
        get: /**
         * @return {?}
         */
        function () {
            return this.innerFormDefinition;
        },
        set: /**
         * @param {?} definition
         * @return {?}
         */
        function (definition) {
            var /** @type {?} */ definitionJSON = definition;
            if (definition && typeof definition === 'string') {
                try {
                    definitionJSON = JSON.parse(definition);
                }
                catch (/** @type {?} */ e) {
                    console.error('set formDefinition error');
                }
            }
            this.innerFormDefinition = definitionJSON;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getControl = /**
     * @return {?}
     */
    function () {
        return undefined;
    };
    /**
     * @return {?}
     */
    ODynamicFormComponent.prototype.getFormControl = /**
     * @return {?}
     */
    function () {
        return undefined;
    };
    /**
     * @param {?} error
     * @return {?}
     */
    ODynamicFormComponent.prototype.hasError = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        return false;
    };
    ODynamicFormComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-dynamic-form',
                    template: "\n    <div fxFlex fxFlexFill fxLayout=\"column\">\n\n      <o-drop-zone fxFlex\n        id=\"main\"\n        *ngIf=\"editMode\"\n        [add-component-emitter]=\"onAddComponent\"\n        [move-component-emitter]=\"onMoveComponent\">\n      </o-drop-zone>\n\n      <ng-template ngFor let-component [ngForOf]=\"formDefinition?.components\">\n        <odf-component fxFlex layout-padding\n          *ngIf=\"ready\"\n          [component]=\"component\"\n          [edit-mode]=\"editMode\"\n          (render)=\"onComponentRendered()\"\n          (change)=\"$event.stopPropagation()\"\n          [add-component-emitter]=\"onAddComponent\"\n          [move-component-emitter]=\"onMoveComponent\"\n          [edit-component-settings-emitter]=\"onEditComponentSettings\"\n          [delete-component-emitter]=\"onDeleteComponent\">\n        </odf-component>\n      </ng-template>\n\n    </div>\n  ",
                    styles: ["\n    .odf-element-options-container{z-index:1;background:#DADADA;cursor:pointer}.odf-element-options-container .odf-element-options-attr{display:inline-flex;align-items:center;padding-left:8px}.odf-element-options-container mat-icon{font-size:14px;cursor:pointer;padding:5px;box-sizing:border-box}odf-element o-column .container-content,odf-element o-row .container-content{padding:0}.odf-element-container{position:relative;cursor:inherit !important}.odf-element-container .component-container{border:1px solid #DADADA}.odf-element-container .component-container o-column.margin-top-bottom,.odf-element-container .component-container o-row.margin-top-bottom{margin:0;padding:8px 0px}\n  "],
                    inputs: [
                        'oattr : attr',
                        'formDefinition: form-definition',
                        'editMode : edit-mode',
                        'entity',
                        'keys',
                        'parentKeys: parent-keys',
                        'columns',
                        'service',
                        'serviceType : service-type',
                        'queryOnInit : query-on-init',
                        'queryOnBind : query-on-bind',
                        'queryOnRender : query-on-render',
                        'registerInParentForm : register-in-parent-form',
                        'autoBinding: automatic-binding',
                        'autoRegistering: automatic-registering'
                    ],
                    outputs: [
                        'render',
                        'submit',
                        'change',
                        'onAddComponent',
                        'onMoveComponent',
                        'onEditComponentSettings',
                        'onDeleteComponent',
                        'onDynamicFormDataLoaded'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    ODynamicFormComponent.ctorParameters = function () { return [
        { type: ActivatedRoute, },
        { type: Injector, },
        { type: ODynamicFormEvents, },
        { type: ElementRef, },
        { type: OFormComponent, decorators: [{ type: Optional }, { type: Inject, args: [forwardRef(function () { return OFormComponent; }),] },] },
    ]; };
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "editMode", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "queryOnInit", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "queryOnBind", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "queryOnRender", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "registerInParentForm", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "autoBinding", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormComponent.prototype, "autoRegistering", void 0);
    return ODynamicFormComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODFElementComponent = (function () {
    function ODFElementComponent(compiler) {
        this.compiler = compiler;
        this.editMode = false;
    }
    /**
     * @return {?}
     */
    ODFElementComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ self = this;
        DFComponents.element(this.component.settings['ontimize-directive'], this.compiler).then(function (factory) {
            if (!self.element) {
                return;
            }
            self.element.clear();
            var /** @type {?} */ cmpRef = self.element.createComponent(factory);
            // cmpRef.instance is a CustomDynamicComponent
            cmpRef.instance['component'] = self.component;
            cmpRef.instance['editMode'] = self.editMode;
            cmpRef.instance['onAddComponent'] = self.addComponentEmitter;
            cmpRef.instance['onMoveComponent'] = self.moveComponentEmitter;
            cmpRef.instance['onEditComponentSettings'] = self.editComponentSettingsEmitter;
            cmpRef.instance['onDeleteComponent'] = self.deleteComponentEmitter;
            cmpRef.instance['render'] = self.render;
        });
    };
    ODFElementComponent.decorators = [
        { type: Component, args: [{
                    selector: 'odf-element',
                    template: "\n    <ng-template #odfElement></ng-template>\n\n    <o-drop-zone\n      fxFlex\n      *ngIf=\"editMode && component.isContainerComponent()\"\n      [component]=\"component\"\n      for-children=\"true\"\n      [add-component-emitter]=\"addComponentEmitter\"\n      [move-component-emitter]=\"moveComponentEmitter\">\n    </o-drop-zone>\n  ",
                    inputs: [
                        'component',
                        'render',
                        'editMode : edit-mode',
                        'addComponentEmitter : add-component-emitter',
                        'moveComponentEmitter : move-component-emitter',
                        'editComponentSettingsEmitter : edit-component-settings-emitter',
                        'deleteComponentEmitter : delete-component-emitter'
                    ]
                },] },
    ];
    /** @nocollapse */
    ODFElementComponent.ctorParameters = function () { return [
        { type: Compiler, },
    ]; };
    ODFElementComponent.propDecorators = {
        "element": [{ type: ViewChild, args: ['odfElement', { read: ViewContainerRef },] },],
    };
    return ODFElementComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template T
 */
var ODFComponentComponent = (function () {
    function ODFComponentComponent(oForm, elRef, injector, events) {
        this.oForm = oForm;
        this.elRef = elRef;
        this.injector = injector;
        this.events = events;
        this.show = true;
        this.components = [];
        this.editMode = false;
        this.render = new EventEmitter();
        this.isDragEnabled = false;
    }
    /**
     * @return {?}
     */
    ODFComponentComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Add the initial component.
        this.addComponent();
        this.events.onChange.subscribe(function () { return _this.checkConditions(); });
    };
    /**
     * @return {?}
     */
    ODFComponentComponent.prototype.checkConditions = /**
     * @return {?}
     */
    function () {
        this.show = true;
    };
    /**
     * @return {?}
     */
    ODFComponentComponent.prototype.addComponent = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ component = DFComponents.createComponent(this.component, this.events, this.injector);
        if (component) {
            // Set the index and readOnly flag.
            component.index = this.components.length;
            // Add this to the instances.
            this.components.push(component);
        }
        else {
            // component wasnt created (triggering render so the dynamic-form would trigger render event correctly)
            this.render.emit(true);
        }
        return component;
    };
    /**
     * @param {?} index
     * @return {?}
     */
    ODFComponentComponent.prototype.removeAt = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        this.components.splice(index, 1);
    };
    /**
     * @param {?} component
     * @return {?}
     */
    ODFComponentComponent.prototype.isContainerComponent = /**
     * @param {?} component
     * @return {?}
     */
    function (component) {
        return component.isContainerComponent();
    };
    /**
     * @return {?}
     */
    ODFComponentComponent.prototype.getDraggableData = /**
     * @return {?}
     */
    function () {
        return this.odfElement ? this.odfElement.component : null;
    };
    ODFComponentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'odf-component',
                    template: "\n    <div *ngFor=\"let comp of components; let i = index;\" class=\"odf-element-container\" fxLayout=\"column\"\n      dnd-draggable [dragData]=\"getDraggableData()\" [dragEnabled]=\"isDragEnabled\">\n\n      <div [ngClass]=\"{'component-container': isContainerComponent(comp), 'component': !isContainerComponent(comp)}\">\n\n        <!-- dnd-draggable-handle -->\n        <odf-element-options\n          (mouseenter)=\"isDragEnabled=true\"\n          (mouseleave)=\"isDragEnabled=false\"\n          fxLayout\n          *ngIf=\"editMode\"\n          [component]=\"comp\"\n          [edit-component-settings-emitter]=\"editComponentSettingsEmitter\"\n          [delete-component-emitter]=\"deleteComponentEmitter\">\n        </odf-element-options>\n\n        <odf-element\n          #odfElement\n          fxLayout=\"column\"\n          [component]=\"comp\"\n          [render]=\"render\"\n          [edit-mode]=\"editMode\"\n          [add-component-emitter]=\"addComponentEmitter\"\n          [move-component-emitter]=\"moveComponentEmitter\"\n          [edit-component-settings-emitter]=\"editComponentSettingsEmitter\"\n          [delete-component-emitter]=\"deleteComponentEmitter\">\n        </odf-element>\n\n      </div>\n\n      <o-drop-zone fxFlex\n        *ngIf=\"editMode\"\n        for-children=\"false\"\n        [component]=\"comp\"\n        [add-component-emitter]=\"addComponentEmitter\"\n        [move-component-emitter]=\"moveComponentEmitter\">\n      </o-drop-zone>\n\n    </div>\n \n  ",
                    inputs: [
                        'component',
                        'editMode : edit-mode',
                        'addComponentEmitter : add-component-emitter',
                        'moveComponentEmitter : move-component-emitter',
                        'editComponentSettingsEmitter : edit-component-settings-emitter',
                        'deleteComponentEmitter : delete-component-emitter'
                    ],
                    outputs: [
                        'render'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    ODFComponentComponent.ctorParameters = function () { return [
        { type: OFormComponent, decorators: [{ type: Optional }, { type: Inject, args: [forwardRef(function () { return OFormComponent; }),] },] },
        { type: ElementRef, },
        { type: Injector, },
        { type: ODynamicFormEvents, },
    ]; };
    ODFComponentComponent.propDecorators = {
        "odfElement": [{ type: ViewChild, args: ['odfElement',] },],
    };
    return ODFComponentComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODFElementOptionsComponent = (function () {
    function ODFElementOptionsComponent() {
    }
    /**
     * @return {?}
     */
    ODFElementOptionsComponent.prototype.onEditOdfElement = /**
     * @return {?}
     */
    function () {
        this.editComponentSettingsEmitter.emit({
            component: this.component
        });
    };
    /**
     * @return {?}
     */
    ODFElementOptionsComponent.prototype.onDeleteOdfElement = /**
     * @return {?}
     */
    function () {
        this.deleteComponentEmitter.emit({
            component: this.component
        });
    };
    ODFElementOptionsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'odf-element-options',
                    template: "\n    <div class=\"odf-element-options-container\" fxFlex>\n      <span fxFlex class=\"odf-element-options-attr\">{{ component.getComponentAttr() }}</span>\n      <mat-icon class=\"material-icons\" (click)=\"onEditOdfElement()\">settings</mat-icon>\n      <mat-icon class=\"material-icons\" (click)=\"onDeleteOdfElement()\">close</mat-icon>\n    </div>\n  ",
                    inputs: [
                        'component',
                        'editComponentSettingsEmitter : edit-component-settings-emitter',
                        'deleteComponentEmitter : delete-component-emitter'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    return ODFElementOptionsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ODropZoneComponent = (function () {
    function ODropZoneComponent() {
        this.DEFAULT_ID = 'o-drop-zone';
        this.CHILDREN_ID_PATH = '-children';
        this.forChildren = false;
    }
    /**
     * @return {?}
     */
    ODropZoneComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.id = this.DEFAULT_ID;
        var /** @type {?} */ attr;
        if (this.component) {
            attr = this.component.getComponentAttr();
            this.id += '-' + attr;
        }
        if (this.forChildren) {
            this.id += this.CHILDREN_ID_PATH;
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    ODropZoneComponent.prototype.onDropEnd = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        var /** @type {?} */ comp = event.dragData;
        var /** @type {?} */ params = {
            component: comp
        };
        if (this.component) {
            if (this.forChildren) {
                // Drop zone from row or column
                params['parent'] = this.component;
            }
            else {
                // Drop zone form element
                params['previousSibling'] = this.component;
            }
        }
        if (comp instanceof BaseComponent) {
            this.moveComponentEmitter.emit(params);
        }
        else {
            this.addComponentEmitter.emit(params);
        }
    };
    /**
     * @return {?}
     */
    ODropZoneComponent.prototype.allowDropFunction = /**
     * @return {?}
     */
    function () {
        var /** @type {?} */ self = this;
        return function (dragData) {
            if (dragData) {
                var /** @type {?} */ fakeDZAttr = self.DEFAULT_ID + '-' + dragData.getComponentAttr();
                var /** @type {?} */ checkSelf = this._elem.id !== fakeDZAttr && this._elem.id !== fakeDZAttr + self.CHILDREN_ID_PATH;
                var /** @type {?} */ checkChildren = true;
                if (dragData instanceof BaseComponent && dragData.isContainerComponent()) {
                    var /** @type {?} */ childrenAttrs = [];
                    // TODO: look for a faster way not to allow drop a component on their children drop zones
                    childrenAttrs = dragData.getChildrenAttrs();
                    if (self.component) {
                        checkChildren = childrenAttrs.indexOf(self.component.getComponentAttr()) === -1;
                    }
                }
                return dragData && checkSelf && checkChildren;
            }
            return false;
        };
    };
    ODropZoneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-drop-zone',
                    template: "\n    <div id=\"{{id}}\" dnd-droppable [allowDrop]=\"allowDropFunction()\" (onDropSuccess)=\"onDropEnd($event)\" [className]=\"'o-drop-zone'\"></div>\n  ",
                    styles: ["\n    .o-drop-zone{width:100%;height:12px;background-size:6px 6px !important;background-image:linear-gradient(-45deg, transparent 46%, rgba(0,0,0,0.38) 49%, rgba(0,0,0,0.38) 51%, transparent 55%)}.o-drop-zone.dnd-drag-enter{height:36px}\n  "],
                    inputs: [
                        'component',
                        'forChildren : for-children',
                        'addComponentEmitter : add-component-emitter',
                        'moveComponentEmitter : move-component-emitter'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODropZoneComponent.prototype, "forChildren", void 0);
    return ODropZoneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var /** @type {?} */ O_DYNAMICFORM_COMPONENTS = [
    ODynamicFormComponent,
    ODFComponentComponent,
    ODFElementComponent,
    ODFElementOptionsComponent,
    ODropZoneComponent
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var DynamicFormModule = (function () {
    function DynamicFormModule() {
        RegisterComponents(DYNAMIC_FORM_BOOTSTRAP);
    }
    DynamicFormModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        FlexLayoutModule,
                        CommonModule,
                        ReactiveFormsModule,
                        ODynamicFormCustomMaterialModule,
                        DndModule.forRoot()
                    ],
                    declarations: O_DYNAMICFORM_COMPONENTS,
                    exports: O_DYNAMICFORM_COMPONENTS,
                    providers: [
                        ODynamicFormEvents
                    ]
                },] },
    ];
    /** @nocollapse */
    DynamicFormModule.ctorParameters = function () { return []; };
    return DynamicFormModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
// This file only reexports content of the `src` folder. Keep it that way.

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

export { ODynamicFormComponent, DynamicFormModule, ODropZoneComponent as ɵg, O_DYNAMICFORM_COMPONENTS as ɵb, ODFComponentComponent as ɵd, ODFElementOptionsComponent as ɵf, ODFElementComponent as ɵe, ODynamicFormEvents as ɵc, ODynamicFormCustomMaterialModule as ɵa };
//# sourceMappingURL=ontimize-web-ngx-dynamicform.es5.js.map
