import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';
import { DndModule } from 'ng2-dnd';
import { ODynamicFormCustomMaterialModule } from './src/shared/custom.material.module';
import { ODynamicFormEvents } from './src/o-dynamic-form.events';
import { RegisterComponents } from './src/components';
import { DYNAMIC_FORM_BOOTSTRAP } from './src/templates/bootstrap.templates';
import { O_DYNAMICFORM_COMPONENTS } from './src/dynamic-form.index';
export { ODynamicFormComponent } from './src/o-dynamic-form.component';
var DynamicFormModule = (function () {
    function DynamicFormModule() {
        RegisterComponents(DYNAMIC_FORM_BOOTSTRAP);
    }
    DynamicFormModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        FlexLayoutModule,
                        CommonModule,
                        ReactiveFormsModule,
                        ODynamicFormCustomMaterialModule,
                        DndModule.forRoot()
                    ],
                    declarations: O_DYNAMICFORM_COMPONENTS,
                    exports: O_DYNAMICFORM_COMPONENTS,
                    providers: [
                        ODynamicFormEvents
                    ]
                },] },
    ];
    DynamicFormModule.ctorParameters = function () { return []; };
    return DynamicFormModule;
}());
export { DynamicFormModule };
//# sourceMappingURL=index.js.map