import { ODynamicFormEvents } from '../o-dynamic-form.events';
export interface ConditionalOptions {
    show?: string;
    when?: any;
    eq?: any;
}
export interface ValidateOptions {
    required?: boolean;
    custom?: string;
    customPrivate?: boolean;
}
export interface ComponentOptions<T, V> {
    'ontimize-directive': string;
    defaultValue?: T | Array<T>;
    type?: string;
    key?: string;
    label?: string;
    input?: boolean;
    required?: boolean;
    multiple?: boolean;
    protected?: boolean;
    unique?: boolean;
    persistent?: boolean;
    tableView?: boolean;
    lockKey?: boolean;
    validate?: V;
    conditional?: ConditionalOptions;
    customConditional?: string;
}
export interface BaseOptions<T> extends ComponentOptions<T, ValidateOptions> {
}
export declare class BaseComponent<T> {
    settings: any;
    events: ODynamicFormEvents;
    data: any;
    index: number;
    constructor(settings: any, events: ODynamicFormEvents, data?: any);
    getNumComponents(): any;
    allowMultiple(): boolean;
    getInputsProperties(): Array<any>;
    getInputsMapping(): any[];
    isContainerComponent(): boolean;
    getChildren(): any;
    getComponentAttr(): any;
    getChildrenAttrs(): Array<string>;
    protected _getChildrenAttrsFromSettings(element: Object, attrs: Array<string>): Array<string>;
}
