var BaseComponent = (function () {
    function BaseComponent(settings, events, data) {
        if (data === void 0) { data = {}; }
        this.settings = settings;
        this.events = events;
        this.data = data;
        this.index = 0;
    }
    BaseComponent.prototype.getNumComponents = function () {
        return this.isContainerComponent() ? this.getChildren().length : 0;
    };
    BaseComponent.prototype.allowMultiple = function () {
        return this.settings.multiple;
    };
    BaseComponent.prototype.getInputsProperties = function () {
        return [];
    };
    BaseComponent.prototype.getInputsMapping = function () {
        var rawProperties = this.getInputsProperties();
        var parsedProperties = [];
        for (var i = 0; i < rawProperties.length; i++) {
            var splitted = rawProperties[i].split(':');
            var propObj = {
                propName: splitted[0].trim(),
                input: splitted[splitted.length - 1].trim()
            };
            parsedProperties.push(propObj);
        }
        return parsedProperties;
    };
    BaseComponent.prototype.isContainerComponent = function () {
        return false;
    };
    BaseComponent.prototype.getChildren = function () {
        return this.settings.children;
    };
    BaseComponent.prototype.getComponentAttr = function () {
        return this.settings.attr;
    };
    BaseComponent.prototype.getChildrenAttrs = function () {
        var attrs = [];
        this._getChildrenAttrsFromSettings(this.settings, attrs);
        return attrs;
    };
    BaseComponent.prototype._getChildrenAttrsFromSettings = function (element, attrs) {
        var _this = this;
        attrs.push(element['attr']);
        if (element['children']) {
            element['children'].forEach(function (e) {
                _this._getChildrenAttrsFromSettings(e, attrs);
            });
        }
        return attrs;
    };
    return BaseComponent;
}());
export { BaseComponent };
//# sourceMappingURL=base.js.map