var find = require('lodash/find');
var cloneDeep = require('lodash/cloneDeep');
import { NgModule, Component, ViewChild } from '@angular/core';
import { DndModule } from 'ng2-dnd';
import { OntimizeWebModule } from 'ontimize-web-ngx';
import { DynamicFormModule } from '../../index';
var DFComponents = (function () {
    function DFComponents() {
    }
    DFComponents.register = function (ontimizeDirective, component, template) {
        var compTemplate = cloneDeep(template);
        compTemplate.module = compTemplate.module || {};
        compTemplate.component.selector = compTemplate.component.selector || 'odf-' + ontimizeDirective;
        compTemplate.component.inputs = compTemplate.component.inputs || ['component', 'data'];
        var decoratedCmp = this.createCustomComponent(compTemplate.component);
        if (!compTemplate.module.declarations) {
            compTemplate.module.declarations = [];
        }
        compTemplate.module.declarations.push(decoratedCmp);
        if (!compTemplate.module.imports) {
            compTemplate.module.imports = [];
        }
        compTemplate.module.imports.push(DynamicFormModule);
        compTemplate.module.imports.push(DndModule);
        compTemplate.module.imports.push(OntimizeWebModule);
        var DynamicComponentModule = (function () {
            function DynamicComponentModule() {
            }
            DynamicComponentModule.decorators = [
                { type: NgModule, args: [compTemplate.module,] },
            ];
            return DynamicComponentModule;
        }());
        DFComponents.components[ontimizeDirective] = {
            component: component,
            metadata: compTemplate.component,
            module: DynamicComponentModule,
            factory: null
        };
    };
    DFComponents.createComponent = function (component, events, data) {
        var ontimizeDirective = component['ontimize-directive'];
        var comp = DFComponents.components[ontimizeDirective];
        if (!comp) {
            console.warn('There is a wrong component definition (ontimize-directive ="%s" does not exists): %O', ontimizeDirective, component);
            return undefined;
        }
        return new comp.component(component, events, data);
    };
    DFComponents.element = function (ontimizeDirective, compiler) {
        if (!DFComponents.components.hasOwnProperty(ontimizeDirective)) {
            ontimizeDirective = 'custom';
        }
        if (DFComponents.components[ontimizeDirective].factoryPromise) {
            return DFComponents.components[ontimizeDirective].factoryPromise;
        }
        DFComponents.components[ontimizeDirective].factoryPromise =
            compiler.compileModuleAndAllComponentsAsync(DFComponents.components[ontimizeDirective].module).then(function (moduleWithFactories) {
                var factory = find(moduleWithFactories.componentFactories, { selector: 'odf-' + ontimizeDirective });
                return factory;
            });
        return DFComponents.components[ontimizeDirective].factoryPromise;
    };
    DFComponents.createCustomComponent = function (compDefinition) {
        var CustomDynamicComponent = (function () {
            function CustomDynamicComponent() {
                this.renderCount = 0;
            }
            Object.defineProperty(CustomDynamicComponent.prototype, "numComponents", {
                get: function () {
                    return this.component.getNumComponents();
                },
                enumerable: true,
                configurable: true
            });
            CustomDynamicComponent.prototype.ngOnInit = function () {
                this.setOntimizeComponentInputs();
            };
            CustomDynamicComponent.prototype.ngAfterViewInit = function () {
                this.onRender();
            };
            CustomDynamicComponent.prototype.setOntimizeComponentInputs = function () {
                if (this.component && this.ontimizeComponent) {
                    var inputsMapping = this.component.getInputsMapping();
                    for (var i = 0; i < inputsMapping.length; i++) {
                        var curr = inputsMapping[i];
                        if (this.component.settings.hasOwnProperty(curr.input)) {
                            this.ontimizeComponent[curr.propName] = this.component.settings[curr.input];
                        }
                    }
                }
            };
            CustomDynamicComponent.prototype.onRender = function () {
                if (!this.render) {
                    return;
                }
                if (this.renderCount > this.numComponents) {
                    return;
                }
                this.renderCount++;
                if (this.renderCount > this.numComponents) {
                    this.render.emit(true);
                }
            };
            CustomDynamicComponent.decorators = [
                { type: Component, args: [compDefinition,] },
            ];
            CustomDynamicComponent.propDecorators = {
                "ontimizeComponent": [{ type: ViewChild, args: ['ontimizeComponent',] },],
            };
            return CustomDynamicComponent;
        }());
        return CustomDynamicComponent;
    };
    DFComponents.components = {};
    return DFComponents;
}());
export { DFComponents };
//# sourceMappingURL=components.js.map