var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewEncapsulation } from '@angular/core';
import { InputConverter } from 'ontimize-web-ngx';
import { BaseComponent } from '../components/base';
var ODropZoneComponent = (function () {
    function ODropZoneComponent() {
        this.DEFAULT_ID = 'o-drop-zone';
        this.CHILDREN_ID_PATH = '-children';
        this.forChildren = false;
    }
    ODropZoneComponent.prototype.ngOnInit = function () {
        this.id = this.DEFAULT_ID;
        var attr;
        if (this.component) {
            attr = this.component.getComponentAttr();
            this.id += '-' + attr;
        }
        if (this.forChildren) {
            this.id += this.CHILDREN_ID_PATH;
        }
    };
    ODropZoneComponent.prototype.onDropEnd = function (event) {
        var comp = event.dragData;
        var params = {
            component: comp
        };
        if (this.component) {
            if (this.forChildren) {
                params['parent'] = this.component;
            }
            else {
                params['previousSibling'] = this.component;
            }
        }
        if (comp instanceof BaseComponent) {
            this.moveComponentEmitter.emit(params);
        }
        else {
            this.addComponentEmitter.emit(params);
        }
    };
    ODropZoneComponent.prototype.allowDropFunction = function () {
        var self = this;
        return function (dragData) {
            if (dragData) {
                var fakeDZAttr = self.DEFAULT_ID + '-' + dragData.getComponentAttr();
                var checkSelf = this._elem.id !== fakeDZAttr && this._elem.id !== fakeDZAttr + self.CHILDREN_ID_PATH;
                var checkChildren = true;
                if (dragData instanceof BaseComponent && dragData.isContainerComponent()) {
                    var childrenAttrs = [];
                    childrenAttrs = dragData.getChildrenAttrs();
                    if (self.component) {
                        checkChildren = childrenAttrs.indexOf(self.component.getComponentAttr()) === -1;
                    }
                }
                return dragData && checkSelf && checkChildren;
            }
            return false;
        };
    };
    ODropZoneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-drop-zone',
                    template: "\n    <div id=\"{{id}}\" dnd-droppable [allowDrop]=\"allowDropFunction()\" (onDropSuccess)=\"onDropEnd($event)\" [className]=\"'o-drop-zone'\"></div>\n  ",
                    styles: ["\n    .o-drop-zone{width:100%;height:12px;background-size:6px 6px !important;background-image:linear-gradient(-45deg, transparent 46%, rgba(0,0,0,0.38) 49%, rgba(0,0,0,0.38) 51%, transparent 55%)}.o-drop-zone.dnd-drag-enter{height:36px}\n  "],
                    inputs: [
                        'component',
                        'forChildren : for-children',
                        'addComponentEmitter : add-component-emitter',
                        'moveComponentEmitter : move-component-emitter'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODropZoneComponent.prototype, "forChildren", void 0);
    return ODropZoneComponent;
}());
export { ODropZoneComponent };
//# sourceMappingURL=o-drop-zone.component.js.map