import { Compiler, Component, ViewChild, ViewContainerRef } from '@angular/core';
import { DFComponents } from './components/components';
var ODFElementComponent = (function () {
    function ODFElementComponent(compiler) {
        this.compiler = compiler;
        this.editMode = false;
    }
    ODFElementComponent.prototype.ngOnInit = function () {
        var self = this;
        DFComponents.element(this.component.settings['ontimize-directive'], this.compiler).then(function (factory) {
            if (!self.element) {
                return;
            }
            self.element.clear();
            var cmpRef = self.element.createComponent(factory);
            cmpRef.instance['component'] = self.component;
            cmpRef.instance['editMode'] = self.editMode;
            cmpRef.instance['onAddComponent'] = self.addComponentEmitter;
            cmpRef.instance['onMoveComponent'] = self.moveComponentEmitter;
            cmpRef.instance['onEditComponentSettings'] = self.editComponentSettingsEmitter;
            cmpRef.instance['onDeleteComponent'] = self.deleteComponentEmitter;
            cmpRef.instance['render'] = self.render;
        });
    };
    ODFElementComponent.decorators = [
        { type: Component, args: [{
                    selector: 'odf-element',
                    template: "\n    <ng-template #odfElement></ng-template>\n\n    <o-drop-zone\n      fxFlex\n      *ngIf=\"editMode && component.isContainerComponent()\"\n      [component]=\"component\"\n      for-children=\"true\"\n      [add-component-emitter]=\"addComponentEmitter\"\n      [move-component-emitter]=\"moveComponentEmitter\">\n    </o-drop-zone>\n  ",
                    inputs: [
                        'component',
                        'render',
                        'editMode : edit-mode',
                        'addComponentEmitter : add-component-emitter',
                        'moveComponentEmitter : move-component-emitter',
                        'editComponentSettingsEmitter : edit-component-settings-emitter',
                        'deleteComponentEmitter : delete-component-emitter'
                    ]
                },] },
    ];
    ODFElementComponent.ctorParameters = function () { return [
        { type: Compiler, },
    ]; };
    ODFElementComponent.propDecorators = {
        "element": [{ type: ViewChild, args: ['odfElement', { read: ViewContainerRef },] },],
    };
    return ODFElementComponent;
}());
export { ODFElementComponent };
//# sourceMappingURL=o-dynamic-form-element.component.js.map