import { ElementRef, EventEmitter, Injector, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { FormControl } from '@angular/forms';
import { Observable } from 'rxjs/Observable';
import { BehaviorSubject } from 'rxjs/BehaviorSubject';
import 'rxjs/add/observable/combineLatest';
import { IFormDataComponent, IFormDataTypeComponent, OFormComponent } from 'ontimize-web-ngx';
import { DynamicFormDefinition } from './o-dynamic-form.common';
import { ODynamicFormEvents } from './o-dynamic-form.events';
export declare class ODynamicFormComponent implements OnInit, IFormDataComponent, IFormDataTypeComponent {
    protected actRoute: ActivatedRoute;
    protected injector: Injector;
    events: ODynamicFormEvents;
    protected elRef: ElementRef;
    protected parentForm: OFormComponent;
    ready: BehaviorSubject<boolean>;
    oattr: string;
    editMode: boolean;
    entity: string;
    keys: string;
    parentKeys: string;
    columns: string;
    service: string;
    serviceType: string;
    queryOnInit: boolean;
    queryOnBind: boolean;
    queryOnRender: boolean;
    registerInParentForm: boolean;
    autoBinding: boolean;
    autoRegistering: boolean;
    innerFormDefinition: DynamicFormDefinition;
    keysArray: string[];
    colsArray: string[];
    _pKeysEquiv: {};
    dataService: any;
    render: EventEmitter<any>;
    submit: EventEmitter<any>;
    change: EventEmitter<any>;
    onAddComponent: EventEmitter<any>;
    onMoveComponent: EventEmitter<any>;
    onEditComponentSettings: EventEmitter<any>;
    onDeleteComponent: EventEmitter<any>;
    onDynamicFormDataLoaded: EventEmitter<Object>;
    protected onFormInitStream: EventEmitter<Object>;
    protected onUrlParamChangedStream: EventEmitter<Object>;
    protected reloadStream: Observable<any>;
    loading: boolean;
    formData: Object;
    protected urlParamSub: any;
    protected urlParams: Object;
    protected onFormDataSubscribe: any;
    constructor(actRoute: ActivatedRoute, injector: Injector, events: ODynamicFormEvents, elRef: ElementRef, parentForm: OFormComponent);
    ngOnInit(): void;
    getSQLType(): number;
    getAttribute(): any;
    ngAfterViewInit(): void;
    configureService(): void;
    registerFormListeners(): void;
    unregisterFormListeners(): void;
    setValue(val: any): void;
    data: any;
    isAutomaticBinding(): boolean;
    isAutomaticRegistering(): boolean;
    protected getCurrentKeysValues(): {};
    doQuery(useFilter?: boolean): void;
    getAttributesToQuery(): any[];
    _setData(data: any): void;
    _emitData(data: any): void;
    queryData(filter: any): void;
    readonly areEmptyComponents: boolean;
    ngOnDestroy(): void;
    onComponentRendered(): void;
    load(): any;
    formDefinition: DynamicFormDefinition;
    getControl(): FormControl;
    getFormControl(): FormControl;
    hasError(error: string): boolean;
}
